<?php
/*
+------------------------------------------------------------------+
| GoMylo.com                                                       |
| Title: Go Mylo Countdown                                         |
| Copyright 2011                                                   |
| Use with this info intact                                        |
+------------------------------------------------------------------+
*/


class modGoMyloCountdownHelper
{
	// Some variable math
function check12($date, $hour, $minute, $ampm, $tzdiff) {
	if ($hour == 12) {
		$newhour = $hour + $ampm - 12 + $tzdiff;
		if ($newhour == 24) {
			$newhour = 0;
			$newdate = date('Y-m-d',strtotime($date) + 86400);
		} else if ($newhour < 0) {
			$newhour = 24 - abs($newhour);
			$newdate = date('Y-m-d',strtotime($date) - 86400);
		} else {
			$newdate = $date;
		}
		if ($minute > 59) {
			echo $err12min;
			$flag = 1;
		} else if ($minute == "") {
			$newminute = "00";
		} else {
			$newminute = $minute;
		}
		return array($newdate, $newhour, $newminute);
	} else if ($hour > 12  && $hour < 24) {
		echo $err12hr;
		$flag = 1;
		if ($minute > 59) {
			echo $err12min;
			$flag = 1;
		} else if ($minute == "") {
			$minute = "00";
		}
	} else {
		$newdate = $date;
		$newhour = $hour + $ampm + $tzdiff;
		if ($minute == "") {
			$newminute = "00";
		} else {
			$newminute = $minute;
		}
		return array($newdate, $newhour, $newminute);
	}
}


//Setup some CSS from the variables
function labelCss($label, $labelstyle, $labellocation, $styling, $cdlink, $justification, $div_id) {
	if ($styling != null) {
		$stylingtag = $styling;
	} else {
		$stylingtag = "";
	}
	
	if ($cdlink && $cdlink != 'http://') {
		$displaycountdown = '<a href="' . $cdlink . '">';
	}
	$displaycountdown .= '<div id="gmctime' . $div_id . '" style="' . $stylingtag . '"></div>';
	if ($cdlink && $cdlink != 'http://') {
		$displaycountdown .= '</a>';
	}
	
	if ($label != null) {
		$labeldiv = '<div style="' . $labelstyle . '">' . $label . '</div>';
		if ($labellocation == "Above") {
			$above = $labeldiv . $displaycountdown;
			return $above;
		}
		if ($labellocation == "Below") {
			$below = $displaycountdown . $labeldiv;
			return $below;
		}
		if ($labellocation == "Left" || $labellocation == "Right") {
			if ($justification == "Left") {
				$stylingtag .= 'float:left;';
				$labelstyle .= 'float:left;';
			}
			if ($justification == "Center") {
				$stylingtag .= 'float:left; position: relative; right: 50%;';
				$labelstyle .= 'float:left; position: relative; right: 50%;';
			}
			if ($justification == "Right") {
				$stylingtag .= 'float:right;';
				$labelstyle .= 'float:right;';
			}
			if ($cdlink && $cdlink != 'http://') {
				$displaycountdown = '<a href="' . $cdlink . '">';
			}
			$displaycountdown .= '<div id="gmctime' . $div_id . '" style="' . $stylingtag . '"></div>';
			if ($cdlink && $cdlink != 'http://') {
				$displaycountdown .= '</a>';
			}
		}
			
		if ($labellocation == "Left") {
			if ($justification == "Right") {
				$left =  $displaycountdown . '<div style="' . $labelstyle . '">' . $label . '</div>';
			} else {
				$left = '<div style="' . $labelstyle . '">' . $label . '</div>' . $displaycountdown;
			}
			return $left;
		}
		
		
		if ($labellocation == "Right") {
			if ($justification == "Right") {
				$right = '<div style="' . $labelstyle . '">' . $label . '</div>' . $displaycountdown;
			} else {
				$right = $displaycountdown . '<div style="' . $labelstyle . '">' . $label . '</div>';
			}
			return $right;
		}
	}
	return $displaycountdown;
}

}

?>