<?php
#####################################################
# Go Mylo Countdown
# Version 1.5.4
# Copyright 2011 GoMylo.com
#####################################################

// no direct access
defined('_JEXEC') or die('Restricted access');
$document = &JFactory::getDocument();

// Include the syndicate functions only once
require_once( dirname(__FILE__).DS.'helper.php' );
require_once( JModuleHelper::getLayoutPath( 'mod_go_mylo_countdown' ) );

#####################################################
// Get variable values from module

   $id					= $params->get('GMC_unique');
   $type				= $params->get('GMC_type');
   $date				= $params->get('GMC_date');
   $cdtime24			= $params->get('GMC_time24');
   $cdtime12			= $params->get('GMC_time12');
   $ampm				= $params->get('GMC_ampm');
   $time_period			= $params->get('GMC_time_period');
   $cookie_reset		= $params->get('GMC_cookie_reset');
   $tzdiff				= $params->get('GMC_tzdiff');
   $pretext				= $params->get('GMC_pretext');
   $posttext			= $params->get('GMC_posttext');
   $premargin			= $params->get('GMC_premargin',0);
   $postmargin			= $params->get('GMC_postmargin',0);
   $label				= $params->get('GMC_label');
   $labelstyle			= $params->get('GMC_labelstyle');
   $labellocation		= $params->get('GMC_labellocation');
   $cdlink				= $params->get('GMC_cdlink');
   $displayunits		= $params->get('GMC_displayunits');
   $altweek				= $params->get('GMC_altweek');
   $altweeks			= $params->get('GMC_altweeks');
   $altday				= $params->get('GMC_altday');
   $altdays				= $params->get('GMC_altdays');
   $althour				= $params->get('GMC_althour');
   $althours			= $params->get('GMC_althours');
   $altminute			= $params->get('GMC_altminute');
   $altminutes			= $params->get('GMC_altminutes');
   $altsecond			= $params->get('GMC_altsecond');
   $altseconds			= $params->get('GMC_altseconds');
   $displayzero			= $params->get('GMC_displayzero');
   $delimiter			= $params->get('GMC_delimiter');
   $styling				= $params->get('GMC_styling');
   $horizvert			= $params->get('GMC_horizvert');
   $justification		= $params->get('GMC_justification');
   $whatnow				= $params->get('GMC_whatnow');
   $displaytext			= $params->get('GMC_displaytext', 'The countdown has ended');
   $showpre				= $params->get('GMC_showpre');
   $showpost			= $params->get('GMC_showpost');
   $redirect			= $params->get('GMC_redirect');
   $moduleclass_sfx		= $params->get('moduleclass_sfx', '');
   $weektext			= JText::_('WEEK_TEXT');
   $weekstext			= JText::_('WEEKS_TEXT');
   $daytext				= JText::_('DAY_TEXT');
   $daystext			= JText::_('DAYS_TEXT');
   $hourtext			= JText::_('HOUR_TEXT');
   $hourstext			= JText::_('HOURS_TEXT');
   $minutetext			= JText::_('MINUTE_TEXT');
   $minutestext			= JText::_('MINUTES_TEXT');
   $secondtext			= JText::_('SECOND_TEXT');
   $secondstext			= JText::_('SECONDS_TEXT');
   $err12hr				= JText::_('ERROR_12_HOUR');
   $err12min			= JText::_('ERROR_12_MINUTE');
   $err12				= JText::_('ERROR_12');
   $err24hr				= JText::_('ERROR_24_HOUR');
   $err24min			= JText::_('ERROR_24_MINUTE');
   $err24				= JText::_('ERROR_24');
   $flag				= 0;

######################################################

if ($id != '') {
	$div_id = '-' . $id;
}

// Assign alternate text to variables if necessary
$alttext = array($altweek, $altweeks, $altday, $altdays, $althour, $althours, $altminute, $altminutes, $altsecond, $altseconds);
$altvariable = array($weekterm, $weeksterm, $dayterm, $daysterm, $hourterm, $hoursterm, $minuteterm, $minutesterm, $secondterm, $secondsterm);
$regvariable = array($weektext, $weekstext, $daytext, $daystext, $hourtext, $hourstext, $minutetext, $minutestext, $secondtext, $secondstext);
$count = count($alttext);
for ($i=0; $i < $count; $i++) {
	if ($alttext[$i]) {
		$altvariable[$i] = $alttext[$i];
	} else {
		$altvariable[$i] = $regvariable[$i];
	}
}



// Check for errors in the time
if ($cdtime24) {
	if ($cdtime24[1] == ":" || $cdtime24[2] == ":") {
		$hrmin = explode(":", $cdtime24);
		if ($hrmin[0] > 23) {
			echo $err24hr;
			$flag = 1;
		}
		if ($hrmin[1] > 59) {
			echo $err24min;
			$flag = 1;
		} else if ($hrmin[1] == "") {
			$hrmin[1] = "00";
		}
		$cdtime24 = $hrmin[0] + $tzdiff . ":" . $hrmin[1];
	} else if ($cdtime24[1] == "." || $cdtime24[2] == ".") {
		$hrmin = explode(".", $cdtime24);
		if ($hrmin[0] > 23) {
			echo $err24hr;
			$flag = 1;
		}
		if ($hrmin[1] > 59) {
			echo $err24min;
			$flag = 1;
		} else if ($hrmin[1] == "") {
			$hrmin[1] = "00";
		}
		$cdtime24 = $hrmin[0] + $tzdiff . ":" . $hrmin[1];
	} else if (strlen($cdtime24) == 3) {
		$hour = $cdtime24[0];
		$minute = $cdtime24[1] . $cdtime24[2];
		if ($hour > 23) {
			echo $err24hr;
			$flag = 1;
		}
		if ($minute > 59) {
			echo $err24min;
			$flag = 1;
		}
		$cdtime24 = $hour + $tzdiff . ":" . $minute;
	} else if (strlen($cdtime24) == 4) {
		$hour = $cdtime24[0] . $cdtime24[1];
		$minute = $cdtime24[2] . $cdtime24[3];
		if ($hour > 23) {
			echo $err24hr;
			$flag = 1;
		}
		if ($minute > 59) {
			echo $err24min;
			$flag = 1;
		}
		$cdtime24 = $hour + $tzdiff . ":" . $minute;
	} else {
		echo $err24;
		$flag = 1;
	}
	
} else if ($cdtime12) {
	if ($cdtime12[1] == ":" || $cdtime12[2] == ":") {
		$hrmin = explode(":", $cdtime12);
		list($newdate, $newhour, $newminute) = modGoMyloCountdownHelper::check12($date, $hrmin[0], $hrmin[1], $ampm, $tzdiff);
		$date = $newdate;
		$cdtime12 = $newhour . ":" . $newminute;
	} else if ($cdtime12[1] == "." || $cdtime12[2] == ".") {
		$hrmin = explode(".", $cdtime12);
		list($newdate, $newhour, $newminute) = modGoMyloCountdownHelper::check12($date, $hrmin[0], $hrmin[1], $ampm, $tzdiff);
		$date = $newdate;
		$cdtime12 = $newhour . ":" . $newminute;
	} else if (strlen($cdtime12) == 1) {
		$hour = $cdtime12[0];
		$minute = "";
		list($newdate, $newhour, $newminute) = modGoMyloCountdownHelper::check12($date, $hour, $minute, $ampm, $tzdiff);
		$date = $newdate;
		$cdtime12 = $newhour . ":" . $newminute;
	} else if (strlen($cdtime12) == 2) {
		$hour = $cdtime12[0] . $cdtime12[1];
		$minute = "";
		list($newdate, $newhour, $newminute) = modGoMyloCountdownHelper::check12($date, $hour, $minute, $ampm, $tzdiff);
		$date = $newdate;
		$cdtime12 = $newhour . ":" . $newminute;
	} else if (strlen($cdtime12) == 3) {
		$hour = $cdtime12[0];
		$minute = $cdtime12[1] . $cdtime12[2];
		list($newdate, $newhour, $newminute) = modGoMyloCountdownHelper::check12($date, $hour, $minute, $ampm, $tzdiff);
		$date = $newdate;
		$cdtime12 = $newhour . ":" . $newminute;
	} else if (strlen($cdtime12) == 4) {
		$hour = $cdtime12[0] . $cdtime12[1];
		$minute = $cdtime12[2] . $cdtime12[3];
		list($newdate, $newhour, $newminute) = modGoMyloCountdownHelper::check12($date, $hour, $minute, $ampm, $tzdiff);
		$date = $newdate;
		$cdtime12 = $newhour . ":" . $newminute;
	} else {
		echo $err12;
		$flag = 1;
	}
} else {
	$time = $date . ' ' . "12:00";
}

if ($type == 'absolute') {
	if ($cdtime24) {
		$time = $date . ' ' . $cdtime24;
	} else if ($cdtime12) {
		$time = $date . ' ' . $cdtime12;
	} else {
		$hour = 12 + $tzdiff;
		$time = $date . ' ' . $hour . ":00";
	}
}

if(!$time) return;
$now = date(time());


// For relative countdown - convert all to seconds
$tp = explode(":", $time_period);
if ($tp[0]) $tp_weeks = $tp[0] * 604800;
if ($tp[1]) $tp_days = $tp[1] * 86400;
if ($tp[2]) $tp_hours = $tp[2] * 3600;
if ($tp[3]) $tp_minutes = $tp[3] * 60;
if ($tp[4]) $tp_seconds = $tp[4];
$time_period = $tp_weeks + $tp_days + $tp_hours + $tp_minutes + $tp_seconds;

// Set target time
if ($type == 'absolute') {
	$target = strtotime($time);
} else {
	$target = $now + $time_period;
}


// Sets a cookie to be used for relative countdowns
$cookiename = 'GMC' . $div_id;
$check_set = JRequest::getString($cookiename, null, 'COOKIE');
if(empty($check_set)){
	// add Set-Cookie: in the header
	$cookie_expires = $now + $time_period + $cookie_reset;
	setcookie($cookiename, $now, $cookie_expires);
   
	// Put the variable and its value in $_COOKIE array.  After that, i can use the following
	// JRequest::getString($cookiename, null, 'cookie');
	// to get the value anywhere
	JRequest::setVar($cookiename, $now, 'COOKIE');
} else {
	$cookie_expires = $check_set + $time_period + $cookie_reset;
}
$elapsed = $now - $check_set;
if(empty($check_set)){
	$elapsed = 0;
}
if ($elapsed < $time_period) {
	$relative_time_period = $time_period - $elapsed;
	$target = $now + $relative_time_period;
}


$countdown = 1;
if ($type == 'relative') {
	if ($elapsed < $time_period && $now < $cookie_expires) {
		$countdown = 1;
	} else {
		$countdown = 0;
	}
}


// Figure out the justification
if ($justification == "Left") {
	if ($labellocation == "Above" || $labellocation == "Below") {
		$justify = "text-align:left";
	} else {
		$justify = "text-align:left";
	}
}
if ($justification == "Center") {
	if ($labellocation == "Above" || $labellocation == "Below") {
		$justify = "text-align:center";
	} else {
		$justify = "position:relative; float:left; left:50%;";
	}
}
if ($justification == "Right") {
	if ($labellocation == "Above" || $labellocation == "Below") {
		$justify = "text-align:right";
	} else {
		$justify = "text-align:right";
	}
}
	

// Display the countdown or do post-countdown routine
if ($countdown == 1) {
	
	if ($flag == 1) {
		print '';
	} else {
		// Output the countdown
		print '
		<div id="gmc-cd' . $div_id . '">';
		print '<div id="gmcpre' . $div_id . '" style="margin:' . $premargin . ';">' . $pretext . '</div>';
		// Get the post-text ready for display
		print '
			<div id="gmcafter' . $div_id . '" style="display:none; ' . $justify . '">' . $displaytext . '</div>
		</div>
		';
		print '
			<div id="datetime' . $div_id . '" style="' . $justify . '">
				' . modGoMyloCountdownHelper::labelCss($label, $labelstyle, $labellocation, $styling, $cdlink, $justification, $div_id) . '
			</div>
			<div style="visibility: hidden; ' . $labelstyle . '">' . $label . '<div style="' . $styling . '"></div></div>'; // hidden div with user-selected styles needed to help maintain pre & post-text margins
		print '
			<div id="gmcpost' . $div_id . '" style="margin:' . $postmargin . '; clear:both;">' . $posttext . '</div>
		';
		
	}
	
} else {
	if ($flag == 1) {
		print '';
	} else {
		// Post-countdown routine
		if ($whatnow == 'text') {
			print '
			<div id="gmc-cd' . $div_id . '">';
			print '<div id="gmcpre' . $div_id . '" style="margin:' . $premargin . 'bottom:0px;">' . $pretext . '</div>';
			// Get the post-text ready for display
			print '
				<div id="gmcafter' . $div_id . '" style="bottom:0px; ' . $justify . '">' . $displaytext . '</div>
			</div>
			';
			print '
				<div id="gmcpost' . $div_id . '" style="margin:' . $postmargin . '; bottom:0px;">' . $posttext . '</div>
			';
		} else {
			header ("Location: $redirect");
		}
	}
}


// Transfer variables to Javascript
$document->addScript('modules/mod_go_mylo_countdown/mod_go_mylo_countdown.js');
JApplication::addCustomHeadTag('
<script type="text/javascript">	
//<![CDATA[
/*
Go Mylo Countdown v1.5.4
Copyright 2011 GoMylo.com
http://www.gomylo.com/joomla-extensions/modules/go-mylo-countdown/
*/

var id' . $id . '			= "' . $div_id . '";
var now' . $id . '		= ' . $now . ';
var target' . $id . '		= ' . $target . ';
var timeperiod' . $id . '		= ' . $time_period . ';
var horizvert' . $id . '		= "' . $horizvert . '";
var displayunits' . $id . '	= "' . $displayunits . '";
var displayzero' . $id . '	= "' . $displayzero . '";
var delimiter' . $id . '		= "' . $delimiter . '";
var weektext' . $id . '		= "' . $altvariable[0] . '";
var weekstext' . $id . '		= "' . $altvariable[1] . '";
var daytext' . $id . '		= "' . $altvariable[2] . '";
var daystext' . $id . '		= "' . $altvariable[3] . '";
var hourtext' . $id . '		= "' . $altvariable[4] . '";
var hourstext' . $id . '		= "' . $altvariable[5] . '";
var minutetext' . $id . '		= "' . $altvariable[6] . '";
var minutestext' . $id . '	= "' . $altvariable[7] . '";
var secondtext' . $id . '		= "' . $altvariable[8] . '";
var secondstext' . $id . ' 	= "' . $altvariable[9] . '";
var whatnow' . $id . '		= "' . $whatnow . '";
var showpre' . $id . '		= "' . $showpre . '";
var showpost' . $id . '		= "' . $showpost . '";
var redirect' . $id . '		= "' . $redirect . '";

//]]>
</script>
');

?>

<script type='text/javascript'>
	cd(id<?php echo $id ?>, now<?php echo $id ?>, target<?php echo $id ?>, timeperiod<?php echo $id ?>, horizvert<?php echo $id ?>, displayunits<?php echo $id ?>, displayzero<?php echo $id ?>, delimiter<?php echo $id ?>, weektext<?php echo $id ?>, weekstext<?php echo $id ?>, daytext<?php echo $id ?>, daystext<?php echo $id ?>, hourtext<?php echo $id ?>, hourstext<?php echo $id ?>, minutetext<?php echo $id ?>, minutestext<?php echo $id ?>, secondtext<?php echo $id ?>, secondstext<?php echo $id ?>, whatnow<?php echo $id ?>, showpre<?php echo $id ?>, showpost<?php echo $id ?>, redirect<?php echo $id ?>);
</script>